# MySQL dump 8.13
#
# Host: localhost    Database: devices
#--------------------------------------------------------
# Server version	3.23.34

#
# Table structure for table 'Commands'
#

CREATE TABLE Commands (
  CommandId int(11) NOT NULL auto_increment,
  Name varchar(30) NOT NULL default '',
  OwnerId int(11) NOT NULL default '0',
  DeviceId int(11) NOT NULL default '0',
  Type tinyint(4) NOT NULL default '0',
  Action text NOT NULL,
  MenuLocationId int(11) NOT NULL default '0',
  MenuOrder tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (CommandId)
) TYPE=MyISAM;

#
# Dumping data for table 'Commands'
#

INSERT INTO Commands VALUES (1,'Turn On',1,1,0,'Turn On',1,1);
INSERT INTO Commands VALUES (2,'Turn Off',1,1,0,'Turn Off',1,2);
INSERT INTO Commands VALUES (3,'Turn on',2,2,0,'Turn on',5,1);
INSERT INTO Commands VALUES (4,'Turn off',2,2,0,'Turn off',5,2);
INSERT INTO Commands VALUES (6,'Switch On',1,3,0,'Turn on',2,2);
INSERT INTO Commands VALUES (7,'Switch Off',1,3,0,'Turn off',2,3);

#
# Table structure for table 'Devices'
#

CREATE TABLE Devices (
  DeviceId int(11) NOT NULL auto_increment,
  Name varchar(30) NOT NULL default '',
  OwnerId int(11) NOT NULL default '0',
  Address varchar(60) NOT NULL default '',
  Count int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (DeviceId)
) TYPE=MyISAM;

#
# Dumping data for table 'Devices'
#

INSERT INTO Devices VALUES (1,'SIP Light',1,'device@iptel.org',117);
INSERT INTO Devices VALUES (2,'SIP A.C.',2,'device@iptel.org',0);
INSERT INTO Devices VALUES (3,'SIP A.C.',1,'device@iptel.org',11);

#
# Table structure for table 'Menus'
#

CREATE TABLE Menus (
  MenuId int(11) NOT NULL auto_increment,
  Name varchar(30) NOT NULL default '',
  OwnerId int(11) NOT NULL default '0',
  MenuLocationId int(11) NOT NULL default '0',
  MenuOrder tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (MenuId)
) TYPE=MyISAM;

#
# Dumping data for table 'Menus'
#

INSERT INTO Menus VALUES (1,'Main Menu',1,1,0);
INSERT INTO Menus VALUES (2,'Bedroom',1,1,1);
INSERT INTO Menus VALUES (3,'Basement',1,1,1);
INSERT INTO Menus VALUES (4,'Main Menu',2,4,0);
INSERT INTO Menus VALUES (5,'Bedroom',2,4,0);
INSERT INTO Menus VALUES (6,'Bathroom',2,5,0);
INSERT INTO Menus VALUES (13,'Main Menu',7,13,0);
INSERT INTO Menus VALUES (12,'Main Menu',6,12,0);
INSERT INTO Menus VALUES (11,'Main Menu',5,11,0);
INSERT INTO Menus VALUES (14,'Main Menu',8,14,0);

#
# Table structure for table 'Users'
#

CREATE TABLE Users (
  UserId int(11) unsigned NOT NULL auto_increment,
  LastName varchar(20) NOT NULL default '',
  FirstName varchar(10) NOT NULL default '',
  Username varchar(30) NOT NULL default '',
  Password varchar(32) binary NOT NULL default '',
  Phone varchar(10) NOT NULL default '',
  Pin varchar(32) binary NOT NULL default '',
  Server varchar(30) NOT NULL default '',
  Address varchar(60) NOT NULL default '',
  Updated timestamp(14) NOT NULL,
  PRIMARY KEY  (UserId),
  UNIQUE KEY Username (Username),
  KEY PasswordIndex (Password)
) TYPE=MyISAM;

#
# Dumping data for table 'Users'
#

INSERT INTO Users VALUES (1,'Miroshnikov','Stan','stan','f4cc71110efa895fcd9ad3155f9eadea','9149540786','81dc9bdb52d04dc20036dbd8313ed055','iptel.org','stan@iptel.org',20050104005407);
INSERT INTO Users VALUES (2,'Miroshnikov','Boris','boris','93f6cdd947f32dfb1ad1c35ac0571fdb','9145556666','81dc9bdb52d04dc20036dbd8313ed055','iptel.org','boris@iptel.org',20050104011948);
INSERT INTO Users VALUES (5,'Stanly','M','stanly','qwerty','9142355795','81dc9bdb52d04dc20036dbd8313ed055','iptel.org','stan@iptel.org',20050104005452);
INSERT INTO Users VALUES (6,'victor','m','victor','victor','9149540784','81dc9bdb52d04dc20036dbd8313ed055','iptel.org','victor@iptel.org',20050104005452);
INSERT INTO Users VALUES (7,'victor','victor','victors','victors','2125558888','81dc9bdb52d04dc20036dbd8313ed055','stanko.org','victor@iptel.org',20050104005452);
INSERT INTO Users VALUES (8,'qwerty','qwerty','qwerty','d8578edf8458ce06fbc5bb76a58c5ca4','2125559999','81b073de9370ea873f548e31b8adc081','qwerty.com','qwerty@qwerty.com',20050104010119);

