<?php

/**
 * gonx_ngram class : Stochastic Language Models (N-Gram)
 * 
 * @package GONX
 * @author Ben Yacoub Hatem <hatem@php.net>
 * @copyright Copyright (c) 2004
 * @version $Id: ngram.class.php,v 1.1 2004/11/08 08:21:15 hatemben Exp $ - 2004-11-08 03:14:59 - N-Gram.class.php
 * @generator dtd2php version 1.0.1
 * @access public
 **/
class gonx_ngram{
	/**
     * Constructor
     * @access protected
     */
	function gonx_ngram(){
		$this->_document = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	}

	var $_document;

	/*
	* Open  N_Gram tag.
	*
	* @param	xml_lang

	*/
	function start_N_Gram($xml_lang = "")
	{
		$resu = ("<N-Gram");

		if ((isset($xml_lang)) and ($xml_lang!=="")){
			$resu .= ' xml:lang="'.$xml_lang.'"';
		}
		$resu .= (">\n  ");
		$this->_document .= $resu;
	}
	
	/*
	* Close  N_Gram tag.
	*
	*/
	function end_N_Gram()
	{
		$this->_document .= "</N-Gram>\n";
	}

	/*
	* Open  import tag.
	*
	* @param	uri	this variable is required
	* @param	name

	*/
	function start_import($uri = "", $name = "")
	{
		$resu = ("<import");

		if ((isset($uri)) and ($uri!=="")){
			$resu .= ' uri="'.$uri.'"';
		} else {
			$resu .= ' <!-- Error occured in import. Need to pass "uri"=... -->';
		}

		if ((isset($name)) and ($name!=="")){
			$resu .= ' name="'.$name.'"';
		}
		$resu .= (">\n  ");
		$this->_document .= $resu;
	}
	
	/*
	* Close  import tag.
	*
	*/
	function end_import()
	{
		$this->_document .= "</import>\n";
	}

	/*
	* Open  lexicon tag.
	*
	* @param	order

	*/
	function start_lexicon($order = "")
	{
		$resu = ("<lexicon");

		if ((isset($order)) and ($order!=="")){
			$resu .= ' order="'.$order.'"';
		}
		$resu .= (">\n  ");
		$this->_document .= $resu;
	}
	
	/*
	* Close  lexicon tag.
	*
	*/
	function end_lexicon()
	{
		$this->_document .= "</lexicon>\n";
	}

	/*
	* Open  token tag.
	*
	* @param	index

	*/
	function start_token($index = "")
	{
		$resu = ("<token");

		if ((isset($index)) and ($index!=="")){
			$resu .= ' index="'.$index.'"';
		}
		$resu .= (">\n  ");
		$this->_document .= $resu;
	}
	
	/*
	* Close  token tag.
	*
	*/
	function end_token()
	{
		$this->_document .= "</token>\n";
	}

	/*
	* Open  ruleref tag.
	*
	* @param	import	this variable is required

	*/
	function start_ruleref($import = "")
	{
		$resu = ("<ruleref");

		if ((isset($import)) and ($import!=="")){
			$resu .= ' import="'.$import.'"';
		} else {
			$resu .= ' <!-- Error occured in ruleref. Need to pass "import"=... -->';
		}

		$resu .= (">\n  ");
		$this->_document .= $resu;
	}
	
	/*
	* Close  ruleref tag.
	*
	*/
	function end_ruleref()
	{
		$this->_document .= "</ruleref>\n";
	}

	/*
	* Open  gramref tag.
	*
	* @param	import	this variable is required

	*/
	function start_gramref($import = "")
	{
		$resu = ("<gramref");

		if ((isset($import)) and ($import!=="")){
			$resu .= ' import="'.$import.'"';
		} else {
			$resu .= ' <!-- Error occured in gramref. Need to pass "import"=... -->';
		}

		$resu .= (">\n  ");
		$this->_document .= $resu;
	}
	
	/*
	* Close  gramref tag.
	*
	*/
	function end_gramref()
	{
		$this->_document .= "</gramref>\n";
	}

	/*
	* Open  tree tag.
	*
	* @param	backoff_scale
	* @param	gap
	* @param	depth

	*/
	function start_tree($backoff_scale = "", $gap = "", $depth = "")
	{
		$resu = ("<tree");

		if ((isset($backoff_scale)) and ($backoff_scale!=="")){
			$resu .= ' backoff-scale="'.$backoff_scale.'"';
		}
		if ((isset($gap)) and ($gap!=="")){
			$resu .= ' gap="'.$gap.'"';
		}
		if ((isset($depth)) and ($depth!=="")){
			$resu .= ' depth="'.$depth.'"';
		}
		$resu .= (">\n  ");
		$this->_document .= $resu;
	}
	
	/*
	* Close  tree tag.
	*
	*/
	function end_tree()
	{
		$this->_document .= "</tree>\n";
	}

	/*
	* Open  interpolation tag.
	*
	* @param	type

	*/
	function start_interpolation($type = "")
	{
		$resu = ("<interpolation");

		if ((isset($type)) and ($type!=="")){
			$resu .= ' type="'.$type.'"';
		}
		$resu .= (">\n  ");
		$this->_document .= $resu;
	}
	
	/*
	* Close  interpolation tag.
	*
	*/
	function end_interpolation()
	{
		$this->_document .= "</interpolation>\n";
	}

	/*
	* Open  component tag.
	*/
	function start_component()
	{
		$this->_document .= "<component>\n";
	}
	
	/*
	* Close  component tag.
	*
	*/
	function end_component()
	{
		$this->_document .= "</component>\n";
	}


   /*
	* 
	* Load a grammar Module to extends class funtionnalities.
	* 
	*/
	function load($module,$params = "")
	{
		
		if (ereg('::',$module)) {
			$d = explode('::',$module);
			$module = $d[0];
			$method = $d[1];
		}
		
		// Usage of absolute path to library
		if (ereg('WIN',PHP_OS)) {
			$path = explode('\\', __FILE__);
		} else $path = explode('/', __FILE__);
		array_pop($path) ;
		$path = implode('/',$path);
		
		if (is_file("$path/ngram_mods/{$module}.class.php")) {
			
			require_once("$path/ngram_mods/$module.class.php");

			$m = new $module($this,$params);
			if (isset($method)) {
				$m->$method($params);
			}
			
		}
	}
	
	/*
	* 
	* Place content between N-Gram tags.
	* 
	* @param	text	text to display
	*/
	function write($text = "") 
	{
	 	$this->_document .= ' '.$text."\n".' ';
	}
		
	/*
	* 
	* Echo generated  N-Gram application to user.
	* 
	*/
	function generate()
	{
		echo $this->_document;
	}
 
}

?>