<?php

/**
 * 
 * @author Mark Headd  <mheadd@voiceingov.org>
 * @changes rewritten for compatibilities with the new vxml module loader
 *
 * $ version 1.0.0 Sun Oct 31 08:46:47 CET 2004 08:46:47 by hatem
 
 Sample usage :
 
<code>
// Name for subdialog
$name = "result";

// Location of subdialog form
$src = "subbie";

//Create parameter array
$params = array('fname'=>"Josh", 'lname'=>"Turner");

// Create grammar for subdialog (to keep this simple, use buitin date type
$grammar = "builtin:grammar/date";

// Create prompt for subdialog
$prompt = "Please state your date of birth ".$params[fname]." ".$params[lname].".";

$page = new gonx_vxml;
$page->start_vxml("", "", "", "", "", "2.0");
$page->start_form("intro");
$page->start_block();
$page->start_prompt("false");
$page->write("Hello, ".$params[fname]." ".$params[lname].". This is a test to see how a subdialog works.");
$page->end_prompt();
$page->end_block();

$page->load("subdb::call",array($name, $src, $params));
//$page->subdb_call($name, $src, $params);

$page->start_block();
$page->start_prompt("false");
$page->write("The date of birth given was, ");

$page->start_value("$name.dob");
$page->write(".");
$page->end_prompt();
$page->end_block();
$page->end_form();

$page->load("subdb::form",array($src, $params, "Field1", $grammar, $prompt, "dob"));
//$page->subdb_form($src, $params, "Field1", $grammar, $prompt, "dob");

$page->end_vxml();

$page->generate();
 </code>
 
*/

class subdb
{
 	
  /**
   * @access private
   * @var object
   */
  var $obj;
 	
 	
  function subdb(&$obj){
    $this->obj = &$obj;
  }
 	
	 	
  /**
   *
   * Function to create subdialog reference.  
   * Parameters accepted = name, src and array with vxml params
   *
   */
  function call($params){
		
		
    // export module params
    $name = $params[0];
    $src = $params[1];
    $params1 = $params[2];
		
		
    $sd_src = '#'.$src;
    $this->obj->start_subdialog("", $sd_src);
    // Iterate through params array and create vxml param elements
    foreach ($params1 as $key => $value)
      {
        $this->obj->start_param_c($key, "", $value);
      }	
    $this->obj->end_subdialog();
  }
 	
  /**
   *
   * Function to create subdialog.  
   * Parameters accepted = id (same as src in subdialog reference
   * params (set as variables in subdialog), field name, grammar
   * prompt text and return variable
   */
  function form($params){
		
    // export module params
    $id = $params[0];
    $params1 = $params[1];
    $field_name = $params[2];
    $grammar = $params[3];
    $prompt = $params[4];
    $return = $params[5];
		
		
    $this->obj->start_form($id);
 		
		
    $this->obj->start_var($return);
		
    // Iterate through params array and create vxml variables
    foreach ($params1 as $key => $value)
      {
        $this->obj->start_var($key, $value);
      }	
		
    $this->obj->start_field($field_name);
    $this->obj->start_grammar("", $grammar);
    $this->obj->end_grammar();
    $this->obj->start_prompt();
    $this->obj->write($prompt);
    $this->obj->end_prompt();
    $this->obj->start_filled();
    $this->obj->start_assign_c($return, $field_name);
    $this->obj->start_return_c($return);
    $this->obj->end_filled();
    $this->obj->end_field();
    $this->obj->end_form();
		
  }
}
 
?>